package dev.pfaff.altargui;

import dev.pfaff.altargui.debug.Profiler;
import dev.pfaff.altargui.host.Host;
import dev.pfaff.altargui.internal.InternalGlobals;
import dev.pfaff.glass.opengl.GL;
import dev.pfaff.log4truth.NamedLogger;

import static java.util.Objects.requireNonNull;

/**
 * Holds {@code static final} references so that usages can be less verbose. As a side effect, the JVM will have more
 * optimization opportunities.
 */
public final class GuiGlobals {
	public static final NamedLogger LOGGER = new NamedLogger("AltarGUI");

//	public static final Pathfinder PATHFINDER = new Pathfinder(GL.context());

	public static final Host HOST = requireNonNull(GuiGlobalsInit.host, "host is uninitialized");

	public static final GL GL = HOST.gl();

	public static void forceInit() {
		InternalGlobals.forceInit();
	}

	public static Profiler profiler() {
		return HOST.profiler();
	}
}
