package dev.pfaff.altargui.debug;

public interface Profiler {
	Nop NOP = new Nop();

	void push(String name);
	void pop();

	default void replace(String name) {
		pop();
		push(name);
	}

	final class Nop implements Profiler {
		private Nop() {}

		@Override
		public void push(String name) {
		}

		@Override
		public void pop() {
		}

		@Override
		public void replace(String name) {
		}
	}
}
