package dev.pfaff.altargui.pathfinder;

import dev.pfaff.altargui.types.Color;

import java.lang.foreign.Arena;
import java.lang.foreign.MemorySegment;
import java.lang.foreign.ValueLayout;
import java.nio.ByteOrder;

import static dev.pfaff.altargui.pathfinder.Pathfinder.MH_PFFillStyleCreateColor;
import static dev.pfaff.altargui.pathfinder.Pathfinder.MH_PFFillStyleDestroy;
import static java.lang.foreign.ValueLayout.JAVA_INT;

public record PFFillStyleRef(MemorySegment ptr) {

	public static final ValueLayout.OfInt COLOR_LAYOUT = JAVA_INT.withOrder(ByteOrder.BIG_ENDIAN);

	public static PFFillStyleRef createColor(Color color) {
		try (var arena = Arena.ofConfined()) {
			var colorBytes = arena.allocateFrom(COLOR_LAYOUT, color.rgba());
			var ptr = (MemorySegment) MH_PFFillStyleCreateColor.invokeExact(colorBytes);
			return new PFFillStyleRef(ptr.reinterpret(Arena.ofAuto(), ptr_ -> {
				try {
					MH_PFFillStyleDestroy.invokeExact(ptr_);
				} catch (Throwable e) {
					throw new RuntimeException(e);
				}
			}));
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
