package dev.pfaff.altargui.pathfinder;

import java.lang.foreign.Arena;
import java.lang.foreign.MemorySegment;

import static dev.pfaff.altargui.pathfinder.Pathfinder.*;

public record PFSceneRef(MemorySegment ptr) {
	public PFSceneProxyRef createSingleThreadedProxy(PFRendererMode mode) {
		try {
			MemorySegment ptr = (MemorySegment) MH_PFSceneProxyCreateFromSceneAndSequentialExecutor.invokeExact(this.ptr(),
					mode.value);
			return new PFSceneProxyRef(ptr.reinterpret(Arena.ofAuto(), ptr_ -> {
				try {
					MH_PFSceneProxyDestroy.invokeExact(ptr_);
				} catch (Throwable e) {
					throw new RuntimeException(e);
				}
			}));
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}

	public PFSceneProxyRef createMultiThreadedProxy(PFRendererMode mode) {
		try {
			MemorySegment ptr = (MemorySegment) MH_PFSceneProxyCreateFromSceneAndRayonExecutor.invokeExact(this.ptr(),
					mode.value);
			return new PFSceneProxyRef(ptr.reinterpret(Arena.ofAuto(), ptr_ -> {
				try {
					MH_PFSceneProxyDestroy.invokeExact(ptr_);
				} catch (Throwable e) {
					throw new RuntimeException(e);
				}
			}));
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
