package dev.pfaff.altargui.render.objects;

import dev.pfaff.altargui.CanvasImpl;
import dev.pfaff.altargui.render.LayeredRenderBuffer;
import dev.pfaff.altargui.render.RenderObject;
import dev.pfaff.altargui.render.Sink;
import dev.pfaff.altargui.render.ViaIntermediateBuffer;
import dev.pfaff.altargui.types.Color;

import java.lang.foreign.MemoryLayout;

public final class DebugRectRenderObject implements RenderObject {
	private final RectRenderObject rect;
	private final OutlineRenderObject outline;

	public DebugRectRenderObject() {
		this.rect = new RectRenderObject();
		this.outline = new OutlineRenderObject();
		this.rect.updateColor(Color.fromRgba(0x0000FF_55));
		this.outline.updateColor(Color.fromRgba(0x0000FF_FF));
	}

	public void updatePositionAndSize(float x, float y, float width, float height) {
		this.rect.updatePositionSize(x, y, width, height);
		var thickness = 2f;
		this.outline.updatePositionSizeThickness(x,
				y,
				x + width,
				y + height,
				thickness);
	}

	@Override
	public int instanceCount() {
		return rect.instanceCount() + outline.instanceCount();
	}

	@Override
	public MemoryLayout instanceLayout() {
		return RectRenderObject.LAYOUT;
	}

	@Override
	public int size() {
		return RenderObject.super.size();
	}

	@Override
	public int program() {
		return rect.program();
	}

	@Override
	public void close() {

	}

	@Override
	public void uploadTo(Sink sink) {
//		var y = new MutableInt(4);
//		activeDebugLayers.stream().forEach(id -> {
//			var program = DEBUG_LAYERS.get(id);
//			var nameWidth = TextWidget.textRenderer.getWidth(program.name);
//			var mat = new Matrix4f();
//			mat.loadIdentity();
//			var y_ = y.v;
//			var nextY = y.v = y_ + 1 + TextWidget.textRenderer.fontHeight + 1;
//			RectWidget.fill(this,
//							0,
//							y_,
//							4 + nameWidth + 4,
//							nextY,
//							RectWidget.GENERIC_HUD_BACKGROUND.colorRgba());
//			TextWidget.paintText(mat, this, program.name, 4, y_ + 1, TextWidget.FONT_SIZING_SCALED, 0.5f, true);
//		});

		this.rect.uploadTo(sink);
		this.outline.uploadTo(sink);
	}

	@Override
	public void uSpecUploadAtUnchecked(ViaIntermediateBuffer buffer, long offset) {
		RenderObject.super.uSpecUploadAtUnchecked(buffer, offset);
	}

	@Override
	public void uSpecUploadCanvas(CanvasImpl canvas) {
		RenderObject.super.uSpecUploadCanvas(canvas);
	}

	@Override
	public void uSpecUploadLayered(LayeredRenderBuffer buffer) {
		RenderObject.super.uSpecUploadLayered(buffer);
	}
}
