package dev.pfaff.altargui.render.objects;

import dev.pfaff.altargui.render.RenderObject;
import dev.pfaff.altargui.types.Color;

public sealed interface IRectRenderObject extends RenderObject permits RectRenderObject, TexturedRectRenderObject {
	void updatePosition(float x, float y);

	void updateSize(float width, float height);

	default void updatePositionSize(float x, float y, float width, float height) {
		updatePosition(x, y);
		updateSize(width, height);
	}

	/**
	 * @param color RGBA
	 */
	void updateColor(Color color);

	@Override
	default int instanceCount() {
		return 1;
	}

	@Override
	default int size() {
		return (int) instanceLayout().byteSize();
	}
}
