package dev.pfaff.altargui.resource;

import dev.pfaff.altargui.io.IOUtil;
import dev.pfaff.altargui.io.Reallocator;
import org.jspecify.annotations.NonNull;

import java.io.IOException;
import java.io.InputStream;
import java.lang.foreign.MemorySegment;
import java.nio.file.Files;
import java.nio.file.Path;

public record PathLoadableResource(Path path) implements LoadableResource {
	@Override
	public MemorySegment readBytes() {
		try {
			return IOUtil.readAllBytes(Reallocator.ofAuto(), this.path);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public @NonNull InputStream openInputStream() throws IOException {
		return Files.newInputStream(this.path);
	}
}
