package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.*;
import org.jetbrains.annotations.NotNull;
import org.jspecify.annotations.Nullable;

import java.util.Objects;

public record KeyedWidget(Key.CallSite key, Widget child) implements SingleChildWidget {
    public KeyedWidget {
        Objects.requireNonNull(child);
    }

    @Override
    public @NotNull AbstractState<? extends SingleChildWidget> instantiate(WidgetInstantiationArgs args) {
        return new State(args);
    }

    private static final class State extends AbstractState<KeyedWidget> {
        private Key.@Nullable CallSite key;

        private State(WidgetInstantiationArgs args) {
            super(args);
        }

        @Override
        public void configure(StateContext stateContext, KeyedWidget widget, boolean init) {
            this.key = widget.key;
            super.configure(stateContext, widget, init);
        }

        @Override
        protected Key.CallSite childKey() {
            assert this.key != null;
            return this.key;
        }
    }
}
