package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.StateContext;
import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.WidgetInstance;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import dev.pfaff.altargui.element.SingleChildWidgetInstance;
import it.unimi.dsi.fastutil.floats.Float2ObjectFunction;
import org.jetbrains.annotations.NotNull;

record TrackingFloatWidget(float a, Float2ObjectFunction<? extends @NotNull Widget> builder) implements Widget {
    @Override
    public @NotNull WidgetInstance instantiate(WidgetInstantiationArgs args) {
        return new State(args);
    }

    private static final class State extends SingleChildWidgetInstance<TrackingFloatWidget> {
        private float a;

        private State(WidgetInstantiationArgs args) {
            super(args);
        }

        @Override
        public void configure(StateContext stateContext, TrackingFloatWidget widget, boolean init) {
            if (init || a != widget.a) {
                setChild(stateContext, widget.builder.get(a = widget.a));
            }
        }
    }
}
