package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.StateContext;
import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.WidgetInstance;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import dev.pfaff.altargui.element.SingleChildWidgetInstance;
import org.jetbrains.annotations.NotNull;

import java.util.function.IntFunction;

record TrackingIntWidget(int a, IntFunction<? extends @NotNull Widget> builder) implements Widget {
    @Override
    public @NotNull WidgetInstance instantiate(WidgetInstantiationArgs args) {
        return new State(args);
    }

    private static final class State extends SingleChildWidgetInstance<TrackingIntWidget> {
        private int a;

        private State(WidgetInstantiationArgs args) {
            super(args);
        }

        @Override
        public void configure(StateContext stateContext, TrackingIntWidget widget, boolean init) {
            if (init || a != widget.a) {
                setChild(stateContext, widget.builder.apply(a = widget.a));
            }
        }
    }
}
