package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.function.BooleanFunction;
import it.unimi.dsi.fastutil.bytes.Byte2ObjectFunction;
import it.unimi.dsi.fastutil.chars.Char2ObjectFunction;
import it.unimi.dsi.fastutil.floats.Float2ObjectFunction;
import it.unimi.dsi.fastutil.shorts.Short2ObjectFunction;
import org.jetbrains.annotations.NotNull;
import org.jspecify.annotations.Nullable;

import java.util.function.DoubleFunction;
import java.util.function.Function;
import java.util.function.IntFunction;
import java.util.function.LongFunction;

public final class TrackingWidgets {
    public static <A> Widget tracking(A a, Function<A, ? extends @NotNull Widget> builder) {
        return new TrackingObjectByEqualityWidget<>(a, builder);
    }

    public static <@Nullable A> Widget trackingIdentity(A a, Function<A, ? extends @NotNull Widget> builder) {
        return new TrackingObjectByIdentityWidget<>(a, builder);
    }

    public static Widget tracking(boolean a, BooleanFunction<? extends @NotNull Widget> builder) {
        return trackingIdentity(a, builder::apply);
    }

    public static Widget tracking(byte a, Byte2ObjectFunction<? extends @NotNull Widget> builder) {
        return new TrackingIntWidget(a, builder);
    }

    public static Widget tracking(short a, Short2ObjectFunction<? extends @NotNull Widget> builder) {
        return new TrackingIntWidget(a, builder);
    }

    public static Widget tracking(char a, Char2ObjectFunction<? extends @NotNull Widget> builder) {
        return new TrackingIntWidget(a, builder);
    }

    public static Widget tracking(int a, IntFunction<? extends @NotNull Widget> builder) {
        return new TrackingIntWidget(a, builder);
    }

    public static Widget tracking(long a, LongFunction<? extends @NotNull Widget> builder) {
        return new TrackingLongWidget(a, builder);
    }

    public static Widget tracking(float a, Float2ObjectFunction<? extends @NotNull Widget> builder) {
        return new TrackingFloatWidget(a, builder);
    }

    public static Widget tracking(double a, DoubleFunction<? extends @NotNull Widget> builder) {
        return new TrackingDoubleWidget(a, builder);
    }
}
