package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.types.Color;

import java.util.List;

import static dev.pfaff.altargui.widgets.MultiChildWidget.stack;

public final class Widgets {
	private static Widget buildCheckbox(boolean checked) {
		return stack(List.of(RectWidget.colored(Color.fromArgb(0xFF_333333)),
									   RectWidget.colored(Color.fromArgb(checked ? 0xFF_00b477 : 0xFF_EEEEEE)).withMargin(1f)))
				.withAbsoluteSize(5, 5);
	}

	private static final Widget CHECKBOX_CHECKED = buildCheckbox(true);
	private static final Widget CHECKBOX_NOT_CHECKED = buildCheckbox(false);
	public static final Widget EMPTY = EmptyWidget.INSTANCE;

	public static final Widget TOOLTIP_BACKGROUND = TooltipBackgroundWidget.INSTANCE.withMargin(4);

	public static Widget checkbox(boolean checked) {
		return checked ? CHECKBOX_CHECKED : CHECKBOX_NOT_CHECKED;
	}
}
